﻿using System.Drawing;
using Netron.GraphLib;
using Netron.GraphLib.Interfaces;

namespace FlowChart
{
    public class FlowChartConnection : Connection
    {
        public override PointF[] GetConnectionPoints()
        {
            PointF[] points;
            PointF t_to = PointF.Empty;
            PointF t_from = Point.Empty;

            if (From != null && To != null && From.Name == "Left" && To.Name == "Left")
            {
                //如果是左侧点连接左侧点，则返回垂直线
                //To?.Name中的?表示会先检查To是否为null
                points = new PointF[2];
                points[0] = From.Location;
                points[1] = new PointF(From.Location.X, To.Location.Y);
                return points;
            }

            points = new PointF[3];
            t_from = From.Location;
            t_to = (To != null) ? To.Location : ToPoint;

            points[0] = t_from;
            points[1] = new PointF(t_to.X, t_from.Y);
            points[2] = t_to;

            return points;
        }


    }
}
